# Pytest with Pytest-HTML Tutorial

This tutorial covers the setup and basic usage of `pytest` along with the `pytest-html` plugin for generating test reports in HTML format. We will configure `pytest` using the `pyproject.toml` file and define custom markers for requirement testing.

## Requirements

- Python 3.6+
- pytest
- pytest-html

You can install the required packages using pip:

```bash
pip install pytest pytest-html
```

## Configuration
We will use `pyproject.toml` for configuring pytest and the `pytest-html` plugin. This approach helps in keeping the configuration centralized and version-controlled.

### Creating pyproject.toml
Create a `pyproject.toml` in your project's root directory and add the following configuration:

```toml
[tool.pytest.ini_options]
minversion = "6.0"
addopts = "--html=report.html"
testpaths = [
    "tests"
]
markers = [
    "smoke: Run the smoke test functions",
    "regression: Run the regression test functions",
    "requirement: Mark tests by their requirement identifier"
]
```

This configuration does the following:

- Sets the minimum pytest version to 6.0.
- Adds default options for pytest, including the generation of an HTML report named report.html.
- Specifies the directory where the tests are located (tests).
- Defines custom markers for smoke tests, regression tests, and requirement-based tests.

### Using Custom Markers
You can use the custom markers defined in `pyproject.toml` to categorize your tests. For example, to mark a test as a requirement test, use the `@pytest.mark.requirement` decorator:

```python
import pytest

@pytest.mark.requirement
def test_example():
    assert True
```

## Running Tests
To run your tests and generate an HTML report, simply execute:

```bash
pytest
```

This command will run all tests found in the testpaths specified in your pyproject.toml and generate an HTML report (report.html) in your project's root directory.

## Viewing the HTML Report
After running the tests, open the report.html file in any web browser to view the detailed test report generated by `pytest-html`.

## Applying Testing and Report Generation to Your Pipeline
You will now add `pytest` and `pytest-html` reports to your pipeline that tie testing to requirements.

1. Create the new component `test-pytest` in the `components` project:

#### template.yml
```yaml
spec:
  inputs:
    image:
      default: ${CI_REGISTRY}/${CI_PROJECT_PATH}/project-image:latest
    stage:
      default: test
    options:
      default: "--html=./docs/reports/report.html"
---

.test:pytest:
  image: $[[ inputs.image ]]
  stage: $[[ inputs.stage ]]
  script:
    - mkdir -p docs/reports
    - pytest $[[ inputs.options ]]
  artifacts:
    paths:
      - docs/reports/
    expire_in: 1 week
```

Push and Tag to publish your new component.

2. Remove `test.yml` from your `workshop` repository and modify the `main.yml`

```yaml
---
variables:
  PROJECT_IMAGE: ${CI_REGISTRY}/${CI_PROJECT_PATH}/project-image:latest
  GITLAB_CLI_IMAGE: ${CI_REGISTRY}/${CI_PROJECT_PATH}/gitlab-release-cli:latest
  PYTHON_PACKAGE_NAME: 'python-package'
  PYTHON_PACKAGE_VERSION: '0.0.0'

stages:
  - docs
  - lint
  - build
  - analysis
  - test
  - package
  - release

workflow:
  rules:
    - if: $CI_COMMIT_TAG
      variables:
        PACKAGE_VERSION: '${CI_COMMIT_TAG}'
    - if: ($CI_COMMIT_TAG == null && $CI_COMMIT_BRANCH != $CI_DEFAULT_BRANCH)
      variables:
        PACKAGE_VERSION: "${CI_COMMIT_BRANCH}_${CI_COMMIT_SHORT_SHA}"
    - if: $CI_COMMIT_BRANCH == $CI_DEFAULT_BRANCH
      variables:
        PACKAGE_VERSION: "latest"
    - if: $CI_COMMIT_TAG =~ /^(\d+\.)?(\d+\.)?(\*|\d+)$/
      variables:
        PYTHON_PACKAGE_VERSION: '${CI_COMMIT_TAG}'

.base:
  image: $PROJECT_IMAGE

include:
  - component: gitlab.home.arpa/developer/components/create-user-guide@1.0.0
    inputs:
      stage: docs
      file: ./README.md
      name: ${CI_PROJECT_NAME}_user_guide
  - component: gitlab.home.arpa/developer/components/clang-format-linting@1.0.0
    inputs:
      stage: lint
      find_directory: ./src
  - component: gitlab.home.arpa/developer/components/clang-tidy-analysis@1.0.0
    inputs:
      stage: analysis
      find_directory: ./src
      ctidy_database: build-${PACKAGE_ARCH}
  - component: gitlab.home.arpa/developer/components/test-pytest@1.0.0
    inputs:
      stage: test
  - local: .gitlab/ci/build.yml
  - local: .gitlab/ci/package.yml
  - local: .gitlab/ci/release.yml
```

3. Modify the `gitlab-ci.jsonnet` file:

```json
local build(arch) =
{
  extends: '.build',
  variables: { PACKAGE_ARCH: arch }
};

local analysis(arch) =
{
  extends: '.analysis:clang-tidy',
  needs: [['build:' + arch]],
  variables: { PACKAGE_ARCH: arch} 
};

local test(arch) =
{
  extends: '.test:pytest',
  needs: [['build:' + arch]],
  variables: { PACKAGE_ARCH: arch }
};

local package(arch) =
{
  extends: '.package',
  needs: [['build:' + arch], ['analysis:' + arch], ['test:' + arch]],
  variables: { PACKAGE_ARCH: arch }
};

local archs = ['x86_64', 'aarch64', 'mips', 'mipsel'];

{
  ['build:' + x]: build(x) for x in archs
}

{
  ['analysis:' + x]: analysis(x) for x in archs
}

{
  ['test:' + x]: test(x) for x in archs
}

{
  ['package:' + x]: package(x) for x in archs
}
```


## Conclusion
Congratulations! You should now have a fully fledged pipeline that automates linting, building, analysis, testing, packaging, and releasing. You can (and should) modify it to meet your needs. Having repeatable, solid CI/CD pipelines and processes ensures you are delivering quality, tested products to your customer. I sincerely hope you have enjoyed this workshop and it has been valuable to you. There are many more topics that have not been covered in this workshop. I encourage you to explore and read the official GitLab documentation to learn about other features that might be useful to you and your team.

[Overview](../../README.md) | [Back](./01_user_guide_creation.md) | [Done](../../)
